Attribute VB_Name = "Modulo"
Option Explicit
Const D1 = 65536
Const D2 = 256
Public Const PI = 3.14159265358979

Public Const TAM_FRM_IMAGEN_H = 5100
Public Const TAM_FRM_IMAGEN_V = 3585
Public imagenGlobal() As Byte
Public bordes() As Long     'bordes de seleccion

Type componentes    'componentes de un pixel determinado
  R As Byte
  G As Byte
  b As Byte
  gris As Byte
End Type

Type subimagenes
  X0 As Integer
  Y0 As Integer
  X1 As Integer
  Y1 As Integer
End Type

' Almacena para cada punto de una recta
' (Image-Cross Section)el valor x, y, y su nivel de gris.
Type puntorecta
  X As Long
  Y As Long
End Type

' Vector de puntos que pertenecen a la Image-Cross Section.
Public Recta() As Long
Public PuntosRecta() As puntorecta
Public RectaDibujada As Boolean

Public FormActual As String       'nombre del form actual
Public contadorImagen As Byte     'n de formularios imagen
Public lut(255) As Byte           'tabla LUT de niveles de gris
Public subimagen As subimagenes
Public subimagenAnterior As subimagenes
Public seleccion As Boolean     'indica si hay cuadro de seleccin


Sub main()
Dim i As Integer
  ChDir App.Path
  MDIFrmPadre.Show
  
  contadorImagen = 1
  RectaDibujada = False
  seleccion = False
  'inicializamos la LUT
  For i = 0 To 255
    lut(i) = i
  Next i
End Sub

'Funcin que devuelve el n de formulario hijo que tiene
'el foco y es un formulario Imagen
Public Function VentanaActiva() As Integer
Dim i As Byte

  For i = 0 To (Forms.Count - 1)
    If (Forms(i).Caption = FormActual) Then
      VentanaActiva = i
      Exit For
    Else
      VentanaActiva = -1
    End If
  Next i
  
End Function

'Funcion que devuelve las tres componentes de un pixel
'determinado
Function InversaRGB(color As Long) As componentes
Dim colorR As Long
Dim colorG As Long
Dim colorB As Long
Dim media As Integer
  
  colorB = (color And 16711680) \ D1
  colorG = (color And 65280) \ D2
  colorR = color And 255
  'If (colorB = colorR) And ((colorR - 5) <= colorG) _
    'And ((colorR + 5) >= colorG) Then
    'colorG = colorR
    'media = colorR
  'Else
    media = (colorR + colorG + colorB) \ 3
  'End If
  
  InversaRGB.R = CByte(colorR)
  InversaRGB.G = CByte(colorG)
  InversaRGB.b = CByte(colorB)
  InversaRGB.gris = CByte(media)
End Function

'procedimiento que lee el formato grfico TFE
Public Sub LeerTFE(nombre As String)
Dim fichero As Integer
  
  fichero = FreeFile
  ReDim imagenGlobal(0 To 319, 0 To 199)
  Open nombre For Binary Access Read As fichero
  Get fichero, , imagenGlobal()
  Close fichero
End Sub

'Procedimiento que transforma la tabla LUT entre los puntos
'i y j con la recta con pendiente a y ordenada en el
'origen b
Public Sub TransformarLUT(i As Byte, j As Byte, a As Single, b As Single)
Dim k As Integer
Dim aux As Long

  For k = i To j
    aux = k * a + b
    If aux > 255 Then aux = 255
    If aux < 0 Then aux = 0
    lut(k) = aux
  Next k
End Sub
'Procedimiento que copia una imagen de origen en el PictureBox
'del formulario destino
Public Sub Copiaimagen(Origen As FrmImagen, Destino As FrmImagen)
Dim i As Integer
Dim j As Integer
Dim color As Long

  For i = 0 To Origen.PicImagen.ScaleWidth - 1
    For j = 0 To Origen.PicImagen.ScaleHeight - 1
      color = Origen.PicImagen.Point(i, j)
      Destino.PicImagen.PSet (i, j), color
    Next j
  Next i
End Sub



Public Sub BorrarRecta(img As PictureBox)
Dim i As Integer

  For i = 0 To UBound(Recta, 1)
    img.PSet (PuntosRecta(i).X, PuntosRecta(i).Y), RGB(Recta(i), Recta(i), Recta(i))
  Next i
  RectaDibujada = False
End Sub
Public Sub guardarSeleccion(f As FrmImagen)
Dim i As Integer
Dim j As Integer
Dim actual As Long
Dim ancho As Integer
Dim alto As Integer

  If seleccion = True Then BorrarSeleccion f, subimagenAnterior
    seleccion = True
    'guardamos los datos
    If (subimagen.X1 < subimagen.X0) And (subimagen.Y1 < subimagen.Y0) Then
      ancho = subimagen.X1
      subimagen.X1 = subimagen.X0
      subimagen.X0 = ancho
      alto = subimagen.Y1
      subimagen.Y1 = subimagen.Y0
      subimagen.Y0 = alto
    ElseIf (subimagen.X1 < subimagen.X0) And (subimagen.Y1 > subimagen.Y0) Then
      ancho = subimagen.X1
      subimagen.X1 = subimagen.X0
      subimagen.X0 = ancho
    ElseIf (subimagen.X1 > subimagen.X0) And (subimagen.Y1 < subimagen.Y0) Then
      alto = subimagen.Y1
      subimagen.Y1 = subimagen.Y0
      subimagen.Y0 = alto
    End If
    
    ancho = subimagen.X1 - subimagen.X0
    alto = subimagen.Y1 - subimagen.Y0
    actual = 0
    ReDim bordes(1500) 'empieza en 0
    'linea superior
    For i = subimagen.X0 To subimagen.X1
      bordes(actual) = f.PicImagen.Point(i, subimagen.Y0)
      actual = actual + 1
    Next i
    'linea inferior
    For i = subimagen.X0 To subimagen.X1
      bordes(actual) = f.PicImagen.Point(i, subimagen.Y1)
      actual = actual + 1
    Next i
    'linea izquierda
    For i = subimagen.Y0 To subimagen.Y1
      bordes(actual) = f.PicImagen.Point(subimagen.X0, i)
      actual = actual + 1
    Next i
    'linea derecha
    For i = subimagen.Y0 To subimagen.Y1
      bordes(actual) = f.PicImagen.Point(subimagen.X1, i)
      actual = actual + 1
    Next i
End Sub

Public Sub BorrarSeleccion(f As FrmImagen, subimg As subimagenes)
Dim i As Integer
Dim aux As Long
  
  seleccion = False
  'linea superior
  aux = 0
  For i = subimg.X0 To subimg.X1
    f.PicImagen.PSet (i, subimg.Y0), bordes(aux)
    aux = aux + 1
  Next i
  'linea inferior
  For i = subimg.X0 To subimg.X1
    f.PicImagen.PSet (i, subimg.Y1), bordes(aux)
    aux = aux + 1
  Next i
  'linea izquierda
  For i = subimg.Y0 To subimg.Y1
    f.PicImagen.PSet (subimg.X0, i), bordes(aux)
    aux = aux + 1
  Next i
  'linea izquierda
  For i = subimg.Y0 To subimg.Y1
    f.PicImagen.PSet (subimg.X1, i), bordes(aux)
    aux = aux + 1
  Next i
End Sub
